;****************************************************************************
;***                                                                      ***
;***        File Name         :  RSDRV.ASM                                ***
;***        Description       :  RS-232C Drive routine                    ***
;***                                                                      ***
;****************************************************************************


include         std.inc
include         rsdrv.inc

                .data

                extrn   PortBase:word           ; RS-232C {I/O|[gAhX
                extrn   ImrPort:word            ; 8259 IMR  I/O|[gAhX

XFlowFlag       byte    ON                      ; XON/XOFFtO
HFlowFlag       byte    ON                      ; RS/CStO

SendEnable      word    ON                      ; OFF = MsCON = M\
SendSize        word    0                       ; M҂̕
SendBuff        byte    SNDBUFSIZE dup (?)    ; Mobt@
SendRPtr        word    0                       ; Mobt@ǎ|C^
SendWPtr        word    0                       ; Mobt@|C^

RecvEnable      word    ON                      ; OFF = MsCON = M\
RecvSize        word    0                       ; Mς݂Ŗ̕
RecvRPtr        word    0                       ; Mobt@ǎ|C^
RecvWPtr        word    0                       ; Mobt@|C^
RecvBuff        byte    RCVBUFSIZE dup (?)    ; Mobt@

                .code

;******************************************************************************
;*                                                                            *
;*          RS-232Cn[hEFA荞݃[`                               *
;*                                                                            *
;******************************************************************************
RsHandler       proc    far private uses ax bx dx ds
                mov     ax, @data
                mov     ds, ax
                assume  ds:@data

                mov     dx, PortBase                ; I/O|[gx[XAhX
                add     dx, IID                     ; 荞ݎʃWX^
                in      al, dx
                sub     dx, IID                     ; ɖ߂
                and     al, 07h                     ; ʂRrbĝݏ

                .if al == 04h                       ; M荞݁^^CAEg̎
                    .repeat
                        in      al, dx                  ; Mf[^ǂݍ
                        mov     ah, XFlowFlag           ; XON/XOFFtO
                        .if ax == (XON or 100h)         ; XON/XOFFt[XONM
                                                        ; M\ԂɂȂ
                            .if SendEnable == OFF       ; ȌԂMsԂ̎
                                mov     SendEnable, ON  ; tO𑗐M\
                                .if SendSize != 0       ; M̂鎞
                                    inc     dx          ; 荞݋WX^
                                    in      al, dx      ; ݂̏󋵂̓ǂݎ
                                    or      al, TxEE    ; M荞݉\
                                    out     dx, al      ; 
                                    dec     dx          ; ɖ߂
                                .endif
                            .endif
                        .elseif ax == (XOFF or 100h)    ; XON/XOFFt[XOFFM
                                                        ; Ms̏ԂɂȂ
                            .if SendEnable == ON        ; ȌԂM\Ԃ̎
                                mov     SendEnable, OFF ; tO𑗐Ms
                                inc     dx              ; 荞݋WX^
                                in      al, dx          ; ݂̏󋵂̓ǂݎ
                                and     al, (not TxEE)  ; M荞݋֎~
                                out     dx, al          ; 
                                dec     dx              ; ɖ߂
                            .endif
                        .else                             ; ʏ핶̎M
                            .if RecvSize != RCVBUFSIZE    ; Mobt@ɋ󂫂
                                mov     bx, RecvWPtr      ; Mobt@|C^
                                mov     RecvBuff[bx], al  ; Mobt@ɕi[
                                inc     bx                ; |C^i߂
                                and     bx, RCVBUFSIZE-1  ; obt@̃bvEh
                                mov     RecvWPtr, bx      ; |C^i[
                                inc     RecvSize          ; Mς݂Ŗ̕
                                .if RecvSize > RECVFULL   ; MEz
                                    call    SendXoffCmd   ; ɎMs`
                                .endif
                            .else
                                call    SendXoffCmd       ; ɎMs`
                            .endif
                        .endif

                        add     dx, LSR                 ; CXe[^XWX^
                        in      al, dx                  ; ݂̒l
                        sub     dx, LSR                 ; ɖ߂
                    .until !(al & 01h)                  ; Mf[^ȂȂ܂

                .elseif al == 02h                       ; M荞݂
                    inc     dx                          ; 荞݋WX^
                    in      al, dx
                    and     al, (not (TxEE or RxRE))    ; M荞݋֎~
                    out     dx, al
                    dec     dx                          ; ɖ߂

                    mov     ah, RxRE                ; 荞݋̂߂̃[N
                                                    ; M荞݉\
                    .if SendSize != 0               ; M҂ꍇ
                        mov     bx, SendRPtr        ; Mobt@ǎ|C^
                        mov     al, SendBuff[bx]    ; Po
                        out     dx, al              ; P𑗐M
                        inc     bx                  ; |C^i߂
                        and     bx, SNDBUFSIZE-1    ; obt@̃bvEh
                        mov     SendRPtr, bx        ; |C^i[
                        dec     SendSize            ; M҂炷
                        .if !zero?                  ; ܂cĂ
                            or      ah, TxEE        ; M荞݉\
                        .endif
                    .endif
                    inc     dx                      ; 荞݋WX^
                    in      al, dx                  ; ݂̋󋵂̎擾
                    or      al, ah                  ; M荞݋H
                    out     dx, al                  ; 
                    dec     dx                      ; ɖ߂
                .endif

                mov     al, EOI                     ; EOIR}h
                .if ImrPort == 0A1h                 ; IMR̃|[gAhX
                    out     PIC2, al                ; 荞݃Rg[EOIo
                .endif
                out     PIC, al                     ; 荞݃Rg[EOIo

                assume  ds:nothing
                iret
RsHandler       endp


;******************************************************************************
;*                                                                            *
;*          VXeɎMoȂƂ`i֐j              *
;*                                                                            *
;*              XON/XOFF̏ꍇ́CXOFF𑗐M                          *
;*              RS/CS̏ꍇ́CRSItɂ                             *
;*                                                                            *
;******************************************************************************
SendXoffCmd     proc    near private
                assume  ds:@data
                .if RecvEnable == ON                ; ȌԂM\̏ꍇ
                    mov     RecvEnable, OFF         ; MMs
                    .if XFlowFlag != OFF            ; XON/XOFFsƂ
                        add     dx, LSR             ; Xe[^XWX^
                        .repeat
                            in      al, dx
                        .until (al & TxRDY)         ; Mz[fBOWX^
                                                    ; ɂȂ܂
                        sub     dx, LSR             ; ɖ߂
                        mov     al, XOFF
                        out     dx, al              ; XOFF𑗐M
                    .endif
                    .if HFlowFlag == ON             ; RS/CSt[sƂ
                        add     dx, MCR             ; f䃌WX^
                        in      al, dx              ; ݂̏󋵂̓ǂݎ
                        and     al, not RTS         ; 
                        out     dx, al              ; RS(RTS)Itɂ
                        add     dx, MCR             ; ɖ߂
                     .endif
                .endif
                assume  ds:nothing
                ret
SendXoffCmd     endp


;******************************************************************************
;*                                                                            *
;*          PM[`                                                *
;*          int      RsGetch(void);                                           *
;*          ߂lF 0ȏ   M                                     *
;*                   -1      M͂Ȃ                               *
;*                                                                            *
;******************************************************************************
RsGetch         proc    uses bx dx
                assume ds:@data
                .if RecvSize != 0                   ; Mς݂̖
                    cli
                    mov     dx, PortBase            ; I/O|[g̃x[XAhX
                    mov     bx, RecvRPtr            ; Mobt@ǎ|C^
                    xor     ah, ah                  ; ʃoCgNA
                    mov     al, RecvBuff[bx]        ; Pǂݎ
                    inc     bx                      ; |C^i߂
                    and     bx, RCVBUFSIZE-1      ; obt@̃bvEh
                    mov     RecvRPtr, bx            ; |C^߂
                    .if ax == 0                     ; MNULL̂Ƃ͖
                        mov     ax, -1
                    .endif
                    dec     RecvSize                ; 炷
                    .if RecvEnable != ON && \       ; MsԂ
                        RecvSize <= RECVEMPTY       ; Mobt@Eȉ
                        mov     RecvEnable, ON      ; tOM\
                        .if XFlowFlag == ON         ; XON/XOFFĂꍇ
                            add     dx, LSR         ; Xe[^XWX^
                            .repeat
                                in      al, dx      ; Xe[^X̓ǂݎ
                            .until al & TxRDY       ; M\ɂȂ܂ő҂
                            sub     dx, LSR         ; ɖ߂
                            mov     al, XON         ; 
                            out     dx, al          ; XON𑗐M
                        .endif
                        .if HFlowFlag == ON         ; RS/CSt[sƂ
                            add     dx, MCR         ; f䃌WX^
                            in      al, dx          ; ݂̏󋵂̓ǂݎ
                            or      al, RTS         ; 
                            out     dx, al          ; RS(RTS)Iɂ
                            sub     dx, MCR         ; ɖ߂
                        .endif
                    .endif
                .else
                    mov     ax, -1                  ; MςݕȂꍇ
                .endif
                sti
                assume  ds:nothing
                ret
RsGetch         endp


;******************************************************************************
;*                                                                            *
;*          PM[`                                                *
;*          void     RsPutch(char SendChar);                                  *
;*          p[^F SendChar    M                                 *
;*          ߂lF     Ȃ                                                 *
;*                                                                            *
;******************************************************************************
RsPutch         proc    uses bx dx, SendChar:byte
                assume  ds:@data
                mov     al, SendChar                ; Mׂ
                .if SendSize != SNDBUFSIZE          ; Mobt@tłȂ
                    mov     bx, SendWPtr            ; Mobt@|C^
                    mov     SendBuff[bx], al        ; obt@Ɋi[
                    inc     bx                      ; |C^i߂
                    and     bx, SNDBUFSIZE-1        ; obt@̃bvEh
                    mov     SendWPtr, bx            ; |C^i[
                    inc     SendSize                ; M҂𑝂₷
                    .if SendEnable == ON            ; M\ԂȂ
                        mov     dx, PortBase        ; I/O|[g̃x[XAhX
                        inc     dx                  ; 荞݋WX^
                        in      al, dx              ; ݂̏󋵂̓ǂݎ
                        or      al, TxEE            ; M荞݉\
                        out     dx, al              ;
                    .endif
                .endif
                ret
RsPutch         endp


                end
