#include <dos.h>

#include	"common.h"             /* ʃCN[ht@C               */
#include	"rs232c.h"             /* RS-232Cpwb_t@C                */


uint    PortBase ;                 /* VA|[gI/Ox[XAhX        */
uint    ImrPort ;                  /* 8259 IMR  I/O|[gAhX          */
uchar	RsInt ;                    /* 荞(INT)xN^ԍ                */
uchar	MaskRsInt ;                /* 8259 IMR ̃}XN                  */
int     FifoBufSize ;              /* FIFOobt@̑傫                   */

static int far *pbase = (int far *)0x00000400L;
                                   /* I/Ox[XAhXe[u̐擪        */

static uint speed_8250[12] =       /* xCfNbXɂ镪l       */
         {1536, 768, 384, 192,  96,  48,  24,  12,   6,   3,   2,   1};
/*  bps     75  150  300  600 1200 2400 4800 9600 192K 384K 576K 1152 */
/*  speed    0    1    2    3    4    5    6    7    8    9   10   11 */

static	char	ChannelSave = 0;   /* I[vς݃VA|[gLp       */

static int OrgIer = 0;
static int OrgImr = 0;
static void (interrupt far* OrgVect)();


void    rsClose(void) ;

/*****************************************************************************/
/*                                                                           */
/*          qr[QRQbI[v                                       */
/*          void       rsOpen(int channel, int speed, int length,            */
/*                            int parities, int stops, int irqNo)            */
/*          p[^Fchannel       VA|[g   1-4 = COM1-COM4       */
/*                      speed         speed_8250[]ւ̃CfbNX           */
/*                                      0=75bps ` 8=19200bps ` 11=1152Kbps */
/*                      length        LN^                           */
/*                                      0=5ޯ,1=6ޯ,2=7ޯ, 3=8ޯ     */
/*                      parities      peB̎                         */
/*                                      0=èȂ,1=è,3=è  */
/*                      stops         Xgbvrbg  (1,2)                */
/*                      irqNo         IRQԍ   -1=̫, 0-15=Iw   */
/*          ߂lF    Ȃ                                                 */
/*                                                                           */
/*****************************************************************************/
void rsOpen(int channel, int speed, int length, int parities, int stops, int irqNo)
{
	uchar rsStatus ;

	if (ChannelSave != 0)                       // ɃI[vĂꍇ
		rsClose();								// @xN[Y
	ChannelSave = channel;                      // I[v|[gԍۑ

    PortBase = *(pbase + channel - 1);          // I/O|[g̃x[XAhX̎擾


// 荞ݔԍw肳ĂȂꍇɂ́A|[gԍɂAIRQԍ肷B

    if (irqNo == -1) {                          // 荞ݔԍw肳ĂȂ
        if ( channel == 1 || channel == 3 )     // COM1  COM3  IRQ3
            irqNo = 3 ;
        else                                    // COM2  COM4  IRQ2
            irqNo = 2 ;
    }


// IRQԍɂAۂ̊荞(INT)ԍ8259̊荞݃}XN߂B

    if (irqNo <= 7) {                           // }X^8259̏ꍇ
        RsInt = irqNo + 0x08;                   // ۂ̊荞(INT)ԍ
        MaskRsInt = 1 << irqNo;                 // 8259荞݃}XN
        ImrPort = 0x21 ;                        // }X^IMR̃AhX
    }
    else {                                      // X[u8259̏ꍇ
        RsInt = irqNo + 0x70;                   // ۂ̊荞(INT)ԍ
        MaskRsInt = 1 << (irqNo - 8);           // 8259荞݃}XN
        ImrPort = 0xA1 ;                        // X[uIMR̃AhX
    }

    FifoBufSize = isNS16550(channel) ;          // FIFOobt@TCY߂

	outp(PortBase+IER, 0);                      // 荞݋֎~

	outp(PortBase+LCR, 0x80 );                  // C䃌WX^DLAB1ɂ
	outp(PortBase, speed_8250[speed]);          // xɂl̐ݒu(LSB)
	outp(PortBase+1, speed_8250[speed] >> 8);   // xɂl̐ݒu(MSB)

	rsStatus = (unsigned char)length;           // LN^
	rsStatus |= ((stops > 1) << 2);             // Xgbvrbg
	rsStatus |= ((parities & 3) << 3);          // peB̎
	outp(PortBase+LCR, rsStatus);               // C䃌WX^̐ݒ

	OrgVect = _dos_getvect( RsInt );		    // 荞݃xN^̕ۑ
	_dos_setvect( RsInt, rsHandler );           // V荞݃nh̓o^

    if ( FifoBufSize != 0 ) {                   // NS16550̏ꍇ
        outp(PortBase+FCR, 0x81);               // FIFO[h̐ݒ
    }

	outp(PortBase+MCR, inp(PortBase+MCR) | 0x0b);
	                                            // 8250̊荞݋
	                                            //   RTS,DTRIɂ
	outp(PortBase+IER, RXE);                    // M荞݋

	inp(PortBase+LSR);                          // C󋵂̃Zbg

	outp(ImrPort, (OrgImr = inp(ImrPort)) & ~MaskRsInt);
                                                // 荞݃}XN̎w

}


/*****************************************************************************/
/*                                                                           */
/*          qr[QRQbN[Y                                       */
/*          void       rsClose(void) ;                                       */
/*          p[^FȂ                                                 */
/*          ߁@@lFȂ                                                 */
/*                                                                           */
/*****************************************************************************/
void rsClose( void )
{
    if ( ChannelSave != 0 ) {
		outp(ImrPort, OrgImr);
		outp(PortBase+IER, OrgIer);
        outp(PortBase+MCR, 0);                  // 8250̊荞݋֎~
                                                //   RTS,DTRItɂ
		_dos_setvect( RsInt, OrgVect );
		ChannelSave = 0 ;
	}
}
