;****************************************************************************
;***																	  ***
;***		File Name         :  ISMACIN.ASM							  ***
;***		Description       :  Check Current DOS mode					  ***
;***																	  ***
;****************************************************************************

include			std.inc


JDOS            EQU     0                           ; PS/55 {DOS
PCDOS           EQU     1                           ; PC DOS
DOSVJ           EQU     2                           ; DOS/V {Ӱ
DOSVE           EQU     3                           ; DOS/V pӰ
AXJ             EQU     4                           ; AX {Ӱ
AXE             EQU     5                           ; AX pӰ
J3100J          EQU     6                           ; J3100 {Ӱ
J3100E          EQU     7                           ; J3100 pӰ
DRDOSJ          EQU     8                           ; DR-DOS {Ӱ
DRDOSE          EQU     9                           ; DR-DOS pӰ
PC9801          EQU    10                           ; PC-9801
PC9801H         EQU    11                           ; PC-9801 Hireso

                .code

;******************************************************************************
;*                                                                            *
;*          ̃`FbN                                                *
;*          int        isMachine(void);                                       *
;*          óF     0 = PS/55 {DOS                                    *
;*                     1 =       pꃂ[h                                   *
;*                     2 = DOS/V {ꃂ[h                                 *
;*                     3 = DOS/V pꃂ[h                                   *
;*                     4 = AX    {ꃂ[h                                 *
;*                     5 = AX    pꃂ[h                                   *
;*                     6 = J3100 {ꃂ[h                                 *
;*                     7 = J3100 pꃂ[h                                   *
;*                     8 = DRDOS {ꃂ[h                                 *
;*                     9 = DRDOS pꃂ[h                                   *
;*                    10 = PC-9801 m[}                                   *
;*                    11 = PC-9801 nC]                                   *
;*                                                                            *
;******************************************************************************
RevAddress      dd      00FE0000h                   ;  pDOS 5.0 ڽ
TDos            db      "BREVAA"                    ; 蕶
TDos_BYTE       =       offset $ - offset TDos      ; 蕶

isMachine		proc	uses ds es si di
				VIDEO   0Fh                         ; Ӱނ̎擾
				.if ah == 0fh                       ; PC9801n̏ꍇ
					mov		dl,PC9801               ; PC9801 ɰ
					xor		ax,ax
					mov		ds,ax
					.if (byte ptr ds:[501h] & 08h)	; Hireso flag
                        inc     dl                  ; PC9801 ʲڿ
                    .endif
                .else

; DRDOS ̔

                    stc                             ; DR DOS
                    MSDOS   4412h                   ; DR DOS 
                    .if !Carry?
                        mov     dl,DRDOSE           ; DR DOS p
                        jmp     CheckDBCS
                    .endif

; J3100 ̔

                    MSDOS   3000h                   ; DOSްޮ݂OEMԍ̎擾
                    .if bh == 29h                   ; OEMԍ
                        jmp     Toshiba
                    .endif
                    MOVSEG	ds,cs					;  pDOS 5.0̔
                    les		di,RevAddress
                    mov		si,offset cs:TDos		; r
                    mov		cx,TDos_BYTE
                    repe	cmpsb					; "BREVAA"̔r
                    .if Zero?						; 񂪌
Toshiba:                mov		dl,J3100J			; J-3100 {
                        xor		ax,ax
                        mov		ds,ax
                        .if !(byte ptr ds:[04D0h] & 1)	; pӰނ̔
                             inc	dl				; J3100 p
                        .endif
                        jmp		isMachineExit
                    .endif

; AX ̔

                    xor     ax,ax
                    mov     ds,ax
                    mov     si,04e0h                ; 40h:0e0h  16޲Ă
                    mov     cx,8
                    .repeat
                        lodsw
                        .if ax != 0                 ;  0 Ȃ AX
                            xor     bx,bx
                            VIDEO   5001h           ; AX Ӱޥ
                            mov     dl,AXJ          ; AX {
                            .if bx == 1h
                                inc     dl          ; AX p
                            .endif
                            jmp     isMachineExit
                        .endif
                    .untilcxz

; PC-DOS / DOS/V / PS/55{DOS ̔

                    mov     ax,4900h
                    int     15h                     ; BIOS߂̎擾
                    .if carry? || bl != 0           ; {DOS or PC-DOS
                        xor     ax,ax
                        mov     ds,ax
                        mov     ax,ds:[7Dh*4]       ; INT 7Dh̎gp
                        or      ax,ds:[7Dh*4+2]
                        mov     dl,PCDOS            ; PC-DOS
                        .if ax != 0
                            dec     dl              ; JDOS {Ӱ
                        .endif
                    .else                           ; DOS/V
						mov		dl,DOSVE			; DOS/V pӰ
CheckDBCS:				MSDOS	GET_DBCS_TABLE		; DBCS޸̎擾
						mov		ax,ds:[si]
						.if ax != 0
							dec		dl				; DOS/V or DR DOS {Ӱ
						.endif
					.endif
				.endif
isMachineExit:
				mov		al,dl
				xor		ah,ah
				ret
isMachine		endp

				end
