/****************************************************************************/
/*		Description : ROMBIOS.ASM Header.									*/
/*		Caution     : must be include all program							*/
/****************************************************************************/

#if !defined(ROMBIOS_H)
#define		ROMBIOS_H

#include	<ctype.h>
#include	<jctype.h>

typedef	unsigned int	uint ;
typedef	unsigned short	ushort ;
typedef	unsigned long	ulong ;
typedef	unsigned char	uchar ;
typedef	unsigned char*	MEM_PTR ;

/*		ʑ̎w		*/

#define	ATRB			0x01
#define	ATRG			0x02
#define	ATRC			0x03
#define	ATRR			0x04
#define	ATRM			0x05
#define	ATRY			0x06
#define	ATRW			0x07
#define HIGHBRIGHT		0x08
#define	B_ATRB			0x10
#define	B_ATRG			0x20
#define	B_ATRC			0x30
#define	B_ATRR			0x40
#define	B_ATRM			0x50
#define	B_ATRY			0x60
#define	B_ATRW			0x70
#define B_HIGHBRIGHT	0x80

/*		r̎w			*/

#define	TOP_LEFT		0
#define TOP_RIGHT		1
#define TOP_HOLIZ		2
#define BOTTOM_HOLIZ	3
#define LEFT_VERT		4
#define RIGHT_VERT		5
#define CROSS_LINE		6
#define CENTER_LEFT		7
#define CENTER_RIGHT	8
#define CENTER_TOP		9
#define CENTER_BOTTOM	10
#define	BOTTOM_LEFT		11
#define BOTTOM_RIGHT	12

#define	REWRITE_ON		(1)
#define	REWRITE_OFF		(1)

#ifdef	LINE_MAIN
	uchar	DisplayRuledLine[13] ={ 
				0x01 , 0x02 , 0x06 , 0x06 , 0x05 , 0x05 , 0x10 ,
				0x19 , 0x17 , 0x16 , 0x15 , 0x03 , 0x04 } ;
#else
	extern	uchar	DisplayRuledLine[13] ;
#endif


typedef	struct {
			uchar	CurrentVmode ;		// ݂̃rfI[h
			int		Column ;			// 
			char	Lines ;				// s
			int		FontHeight ;		// tHg̍
}VIDEO_INF ;


#define	NOCHECK		0					// for GetKey

#define ClearCursor()			SetCursorType(32,0)

int		isMachine(void);

void far *SetVramSegment(void);
void	GetVideoInfo(VIDEO_INF*);
void	PutStringAbs(int , int , char* , int);
void	PutStringAbs2(int , int , char* , int, int);
void	ScreenRewrite(int , int);
void	PutLoopChar(int , int , char , int , int);
void	SetCursorType(int , int);
void	ScrollUp(int , int , int , int , int);
void	SetCursorType(int , int );
void	SetCursorPos(int , int );
void	SaveCursor(void);
void	RestoreCursor(void);

int		GetKey(uint);
int		GetShiftStatus(void);
void	KeyBufClr(void);

#endif
